// EasySYS.h : main header file for the EASYSYS application
//

#if !defined(AFX_EASYSYS_H__D2E8EF14_FEB3_48DA_8E6E_52128E00C0FC__INCLUDED_)
#define AFX_EASYSYS_H__D2E8EF14_FEB3_48DA_8E6E_52128E00C0FC__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#ifndef __AFXWIN_H__
	#error include 'stdafx.h' before including this file for PCH
#endif

#include "resource.h"		// main symbols

/////////////////////////////////////////////////////////////////////////////
// CEasySYSApp:
// See EasySYS.cpp for the implementation of this class
//

class CEasySYSApp : public CWinApp
{
public:
	CEasySYSApp();

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CEasySYSApp)
	public:
	virtual BOOL InitInstance();
	virtual BOOL InitApplication();
	//}}AFX_VIRTUAL

// Implementation

	//{{AFX_MSG(CEasySYSApp)
	afx_msg void OnAppLink();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

#define CONFIG_PATH _T("Software\\EasySYS")
#define CONFIG_NAME_LOCATION _T("LastLocation")
#define CONFIG_NAME_AUTHOR _T("LastAuthor")
#define ENVIRONMENT_PATH_SYSTEM _T("SYSTEM\\CurrentControlSet\\Control\\Session Manager\\Environment")
#define ENVIRONMENT_PATH_USER _T("Environment")
#define WINDDK_PATH _T("SOFTWARE\\Microsoft\\WINDDK")
#define DIALOG_CAPTION _T("EasySYS 0.3.2.7") //txt display in dialog

struct AppOption
{
	int nClass;
	int nID;
	const TCHAR* szInter;
	const TCHAR* szDisp;
	bool bChecked;
};
//total options
#define OPTION_NUM 10
//for ddk version
#define DDK_NUM 5
//class id of ddk version
#define DDK_VERSION 0x11
//id of each ddk version
#define DDK_W2K 1
#define DDK_WXP 2
#define DDK_W2K3 3
#define DDK_WDK 4
#define DDK_WDK_7 5

//for target os
#define TARGET_OS_NUM 5
//class id of target os
#define TARGET_OS 0x22
//id of each os
#define TOS_W2K IDC_TOS_W2K
#define TOS_WXP IDC_TOS_WXP
#define TOS_W2K3 IDC_TOS_W2K3
#define TOS_W2K8 IDC_TOS_W2K8
#define TOS_W7 IDC_TOS_W7

extern AppOption g_options[OPTION_NUM];

//define two function for combo box options
BOOL GetCurOption(int nClass, int *pnID);
int SetCurOption(int nClass, int nID);
//define two function for check box options
int GetCheckItem(int nClass, int nIndex);
int SetCheckItem(int nClass, int nID);
/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_EASYSYS_H__D2E8EF14_FEB3_48DA_8E6E_52128E00C0FC__INCLUDED_)
