// EasySYSDlg.cpp : implementation file

#include "stdafx.h"
#include "EasySYS.h"
#include "EasySYSDlg.h"
#include "time.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

//////////////////////////////////////////////////////////////////////////

#define UWM_TRAY_NOTIFICATION   WM_USER+0
#define TYPE_VS2008 0
#define TYPE_VS2005 1
#define TYPE_VS6 2

//#define STR_BLOGURL "http://hi.baidu.com/517826104" //(*^_^*) Add by ...
#define STR_BLOGURL "http://hi.baidu.com/ithurricane" //(*^_^*) Add by ...

TCHAR g_bufDDKPath[MAX_PATH] = {0};
CString g_bufBuildLine;

int nIDEtype = TYPE_VS6;

///////////////////////////////////////////////////////////////////////////////////
//---------------------------------------------------------------------------------
//  ÁE    GenerateRandomStrings
//
//  :      int nSize
//             ַĳ
//  
//  ֵ:    Cstring
//             ַ
//          
//  :  ַ
//             (ȻԼӸΪType:,ĸ,E; żд˸򵥵)
//--------------------------------------------------------------------------------- 

CString GenerateRandomStrings(int nSize)   
{
	char c; 
	//char *strTitle = new char[nSize];   
	
	// ֲ̫
	char strTitle[64] = {0};   

	for(int i=0; i<nSize; i++)  
	{
		srand((unsigned int)((i+1)*nSize*GetTickCount()));
		c = (rand() % 255);  
		
		// ڱEмȁEֻĸ()
//		if (i ==0 ||i> 8 && i<11)
//		{
			while(!IsCharAlphaNumeric(c))
			{
				c = ((rand() % 74) + 48);
			}
//		}		
		strTitle[i] = c;   
	}

	strTitle[nSize] = '\0';

	return strTitle;

/*	//۸֮~
	//(*^_^*)

	CString ChiChou =strTitle;
	return ChiChou;*/
}

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnLink();
	afx_msg void OnBeep();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//CAboutDlg::OnAppAbout() ;
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
	ON_BN_CLICKED(IDC_LINK, OnLink)
	ON_BN_CLICKED(IDC_BEEP, OnBeep)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()



BOOL CAboutDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	return TRUE; 
}

void CAboutDlg::OnLink() 
{
	// TODO: Add your control notification handler code here
	::ShellExecute(::GetDesktopWindow(), "open", STR_BLOGURL,NULL,NULL,SW_SHOWNORMAL);
}

void CAboutDlg::OnBeep() 
{
	for(int i=1; i<=5; i++)
	{
		for(int j=1;j<=10;j++)
		{
			Beep(10*i*j,100);
		}
	}
}




/////////////////////////////////////////////////////////////////////////////
// CEasySYSDlg dialog

CEasySYSDlg::CEasySYSDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CEasySYSDlg::IDD, pParent), m_trayIcon(IDR_TRAYICON)
{
	//{{AFX_DATA_INIT(CEasySYSDlg)
	m_strPrjName = _T("");
	m_strPrjPath = _T("");
	m_strPrjAuthor = _T("");
	m_strPrjComment = _T("");
	m_bOpenFolder = FALSE;
	m_bOpenProject = FALSE;
	m_bCreateTestApp = FALSE;
	type = 0;
	m_bAutoQuit = TRUE;
	
	g_bufBuildLine = "";

	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	ReadPathFromReg();
}

void CEasySYSDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CEasySYSDlg)
	DDX_Text(pDX, IDC_PRJ_NAME, m_strPrjName);
	DDX_Text(pDX, IDC_LOCATION, m_strPrjPath);
	DDX_Control(pDX, IDC_IDE_TYPE, m_IDEType);
	DDX_Text(pDX, IDC_AUTHOR, m_strPrjAuthor);
	DDX_Text(pDX, IDC_COMMENT, m_strPrjComment);
	DDX_Check(pDX, IDC_OPENFOLDER, m_bOpenFolder);
	DDX_Check(pDX, IDC_OPENPRJ, m_bOpenProject);
	DDX_Control(pDX, IDC_NAME, m_btnName);
	DDX_Control(pDX, IDC_BROWSE_FOLDER, m_btnBrowser);
	DDX_Control(pDX, IDOK, m_btnCreate);
	DDX_Control(pDX, IDCANCEL, m_btnClose);
	DDX_Check(pDX, IDC_AUTOQUIT, m_bAutoQuit);
	DDX_Check(pDX, IDC_CREATETESTAPP, m_bCreateTestApp);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CEasySYSDlg, CDialog)
	//{{AFX_MSG_MAP(CEasySYSDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BROWSE_FOLDER, OnBrowseFolder)
	ON_BN_CLICKED(IDOK, OnCreate)
	ON_CBN_SELCHANGE(IDC_DDK_VERSION, OnSelchangeDdkVersion)
	ON_CBN_SELCHANGE(IDC_IDE_TYPE, OnSelectIdeType)
	ON_BN_CLICKED(IDC_NAME, OnCreateName)
	ON_MESSAGE(UWM_TRAY_NOTIFICATION, OnTrayNotification)
	ON_COMMAND(ID_APP_OPEN, OnAppOpen)
	ON_COMMAND(ID_APP_SUSPEND, OnAppSuspend)
	ON_EN_CHANGE(IDC_AUTHOR, OnChangeAuthor)
	ON_BN_CLICKED(IDC_TOS_W2K, OnTosW2k)
	ON_BN_CLICKED(IDC_TOS_WXP, OnTosWXP)
	ON_BN_CLICKED(IDC_TOS_W2K3, OnTosW2K3)
	ON_BN_CLICKED(IDC_TOS_W2K8, OnTosW2K8)
	ON_BN_CLICKED(IDC_TOS_W7, OnTosW7)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CEasySYSDlg message handlers

BOOL CEasySYSDlg::OnInitDialog()
{
	CDialog::OnInitDialog();
	
	//Add by ChiChou
	//Get Date and Time
	CTime m_Time = CTime::GetCurrentTime();
	m_strDate.Format("%i-%i-%i",m_Time.GetYear(),m_Time.GetMonth(),m_Time.GetDay());
	
	// Add "About..." menu item to system menu.
	// IDM_ABOUTBOX must be in the system command range.

	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	SetIcon(m_hIcon, TRUE);//Set big and small icon
	
	//initialize location
	//initialize ddk
	for (int i=0; i<OPTION_NUM; i++)
	{
		if (g_options[i].nClass == DDK_VERSION)
		{
			int iIndex = ((CComboBox *)GetDlgItem(IDC_DDK_VERSION))->AddString(g_options[i].szDisp);
			((CComboBox *)GetDlgItem(IDC_DDK_VERSION))->SetItemData(iIndex,g_options[i].nID);
			if (g_options[i].bChecked)
			{
				((CComboBox *)GetDlgItem(IDC_DDK_VERSION))->SetCurSel(iIndex);
			}
		}
	}

	//initialize target os
	//nothing	
	m_IDEType.AddString("VC 6.0");
	m_IDEType.AddString("VS 2005");
	m_IDEType.AddString("VS 2008");

	m_IDEType.SetCurSel(2);
	//GetDlgItem(IDC_IDE_TYPE)->SetFocus(); 

	//
	OnSelectIdeType();

	// GenerateRandomStrings
	OnCreateName();


	((CButton*)GetDlgItem(IDC_DDK_VERSION))->SetCheck(0);
	((CButton*)GetDlgItem(IDC_TOS_W2K))->SetCheck(0);
	((CButton*)GetDlgItem(IDC_TOS_WXP))->SetCheck(1);
	((CButton*)GetDlgItem(IDC_TOS_W2K3))->SetCheck(0);
	((CButton*)GetDlgItem(IDC_TOS_W2K8))->SetCheck(0);
	((CButton*)GetDlgItem(IDC_TOS_W7))->SetCheck(0);


	//Add by ChiChou
	((CButton*)GetDlgItem(IDC_AUTOQUIT))->SetCheck(1);		
	((CButton*)GetDlgItem(IDC_OPENFOLDER))->SetCheck(1);	
	((CButton*)GetDlgItem(IDC_OPENPRJ))->SetCheck(0);		
	((CButton*)GetDlgItem(IDC_CREATETESTAPP))->SetCheck(1);	

	//
	OnSelchangeDdkVersion();

	//
	OnChangeAuthor();
	
	//
	m_trayIcon.SetNotificationWnd (this, UWM_TRAY_NOTIFICATION);
	m_trayIcon.SetIcon (IDR_MAINFRAME);
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CEasySYSDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CEasySYSDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CEasySYSDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

//call back for browse folder, direct into the folder of last selected
int CALLBACK BrowseCallbackProc(HWND hwnd,UINT uMsg,LPARAM lParam,LPARAM lpData)
{
	if (BFFM_INITIALIZED == uMsg)
	{
		::SendMessage(hwnd,BFFM_SETSELECTION,TRUE,lpData);
	}
	return 0;
}

void CEasySYSDlg::OnBrowseFolder()//Get project folder
{
	BROWSEINFO bi;
	TCHAR szFolder[MAX_PATH];
	memset(&bi,0,sizeof(bi));

	bi.hwndOwner = this->GetSafeHwnd();
	bi.lpszTitle = _T("Select a folder...");
	bi.pidlRoot = NULL;
	bi.pszDisplayName = (LPTSTR)&szFolder;
	bi.lpfn = BrowseCallbackProc;
	bi.lParam = (LPARAM)m_strPrjPath.GetBuffer(0);

	LPITEMIDLIST pidl;
	pidl = SHBrowseForFolder(&bi);

	if (pidl == NULL)
	{
		return;
	}
	else
	{
		SHGetPathFromIDList(pidl, (LPTSTR)&szFolder);
		GetDlgItem(IDC_LOCATION)->SetWindowText(szFolder);
		m_strPrjPath = szFolder;
	}
}

void CEasySYSDlg::OnChangeAuthor() 
{
	// TODO: If this is a RICHEDIT control, the control will not
	// send this notification unless you override the CDialog::OnInitDialog()
	// function and call CRichEditCtrl().SetEventMask()
	// with the ENM_CHANGE flag ORed into the mask.
	
	// TODO: Add your control notification handler code here
	UpdateData();
	CString StrComment;
	StrComment.Format("Copyright (C) 2010 %s.",m_strPrjAuthor);
	GetDlgItem(IDC_COMMENT)->SetWindowText(StrComment);
}

void CEasySYSDlg::OnCreate() 
{
	UpdateData();

	//check project name
	if (m_strPrjName.IsEmpty())
	{
		MessageBox(_T("Please input project name."), DIALOG_CAPTION, MB_ICONSTOP);
		return;
	}

	//Check illegal char
	if (m_strPrjName.Find("\\")	!= -1 ||
		m_strPrjName.Find("/")	!= -1 ||
		m_strPrjName.Find("<")	!= -1 ||
		m_strPrjName.Find(">")	!= -1 ||
		m_strPrjName.Find("?")	!= -1 ||
		m_strPrjName.Find(":")	!= -1 ||
		m_strPrjName.Find("\"")	!= -1 ||
		m_strPrjName.Find("*")	!= -1 )
	{
		MessageBox(_T("Illegal char in Project Name."), DIALOG_CAPTION, MB_ICONSTOP);
		return;
	}

	//check location
	if (m_strPrjPath.IsEmpty())
	{
		MessageBox(_T("Please input project location."), DIALOG_CAPTION, MB_ICONSTOP);
		return;
	}

	//Remove spaces [By ChiChou]
	m_strPrjName.TrimLeft();
	m_strPrjName.TrimRight();

	SavePathToReg();
	CheckDDK();

	//check target os
	if(!CheckTargetOS()) return;

	// "C:\WINDDK\3790.1830"
	GetDDKPath();
	
	//WXPBASE
	// m_strDDKVer

	//set value of PROJECT_MYBUILD_LINE
	if (-1 == SetBuildLineValue())
	{
		//MessageBox(_T("Please select more than one target OS."), DIALOG_CAPTION, MB_OK);
		return;
	}

	if(NULL == g_bufDDKPath)
	{
		MessageBox(_T("Can't get DDK Path."), DIALOG_CAPTION, MB_OK);
		return;
	}

	int iSysResult = 1;
	int iAppResult = 1;

	//create project
	if (TYPE_VS2005 == nIDEtype || TYPE_VS2008 == nIDEtype)
	{
		// default
		iSysResult = CreateSysProject();

		if (TRUE == m_bCreateTestApp)
		{
			iAppResult = CreateConsoleProject();
		}
		else
		{
			iAppResult = 0;
		}

		iSysResult = iSysResult | iAppResult;
	}
	else
	{
		// VC 6.0
		iSysResult = CreateSysProject_vc6();
	}


	if(iSysResult == 0)
	{
		CString strPath, strProjectName, strExtraName;
		GetDlgItem(IDC_LOCATION)->GetWindowText(strPath);
		GetDlgItem(IDC_PRJ_NAME)->GetWindowText(strProjectName);

		strPath += _T("\\") + strProjectName;

		if(!strPath.IsEmpty() && m_bOpenFolder) ShellExecute(m_hWnd, "open", strPath,NULL,NULL,SW_SHOW);

		if (TYPE_VS2005 == nIDEtype)
		{	
			strExtraName = _T(".sln");
		}
		else if (TYPE_VS2008 == nIDEtype)
		{	
			strExtraName = _T(".sln");
		}
		else
		{
			strExtraName = _T(".dsw");
		}
		strPath += _T("\\") + strProjectName + strExtraName;

		if(!strPath.IsEmpty() && m_bOpenProject)
		{
			ShellExecute(m_hWnd, "open", strPath,NULL,NULL,SW_SHOW);
		}
		
		MessageBox("Create project successful.",DIALOG_CAPTION,MB_ICONINFORMATION);
		
		if(m_bAutoQuit) 
		{
			CEasySYSDlg::OnAppSuspend();
		}
	}
}

BOOL CEasySYSDlg::CheckTargetOS()
{
	//get target os option, and check it
	m_nTosNum = 0;
	if( ((CButton *)GetDlgItem(IDC_TOS_W2K))->GetCheck() 
		&& GetDlgItem(IDC_TOS_W2K)->IsWindowEnabled() )
	{
		SetCheckItem(TARGET_OS, TOS_W2K);
		m_nTosNum++;
	}

	if( ((CButton *)GetDlgItem(IDC_TOS_WXP))->GetCheck() 
		&& GetDlgItem(IDC_TOS_WXP)->IsWindowEnabled() )
	{
		SetCheckItem(TARGET_OS, TOS_WXP);
		m_nTosNum++;
	}

	if( ((CButton *)GetDlgItem(IDC_TOS_W2K3))->GetCheck() 
		&& GetDlgItem(IDC_TOS_W2K3)->IsWindowEnabled() )
	{
		SetCheckItem(TARGET_OS, TOS_W2K3);
		m_nTosNum++;
	}

	if( ((CButton *)GetDlgItem(IDC_TOS_W2K8))->GetCheck() 
		&& GetDlgItem(IDC_TOS_W2K8)->IsWindowEnabled() )
	{
		SetCheckItem(TARGET_OS, TOS_W2K8);
		m_nTosNum++;
	}
	if( ((CButton *)GetDlgItem(IDC_TOS_W7))->GetCheck() 
		&& GetDlgItem(IDC_TOS_W7)->IsWindowEnabled() )
	{
		SetCheckItem(TARGET_OS, TOS_W7);
		m_nTosNum++;
	}

	//check
	if (m_nTosNum <= 0)
	{
		MessageBox(_T("Please select more than one target OS."), DIALOG_CAPTION, MB_ICONSTOP);
		return FALSE;
	}

	return TRUE;
}

BOOL CEasySYSDlg::CheckDDK()
{
	int nIndex = ((CComboBox *)GetDlgItem(IDC_DDK_VERSION))->GetCurSel();
	int nOptionID = ((CComboBox *)GetDlgItem(IDC_DDK_VERSION))->GetItemData(nIndex);
	nIndex = SetCurOption(DDK_VERSION,nOptionID);
	m_strDDKVer = g_options[nIndex].szInter;
	return CheckDDKEnvironment();
}

void CEasySYSDlg::GetDDKPath()
{
	CString strDDKEnvironmentName = m_strDDKVer + _T("BASE");
	DWORD dwBufLen = MAX_PATH;
	DWORD dwType = REG_SZ;
	BOOL bRet = FALSE;
	HKEY hKeyEnvironment;

	if(ERROR_SUCCESS == RegOpenKeyEx(HKEY_CURRENT_USER, ENVIRONMENT_PATH_USER,
		0, KEY_READ, &hKeyEnvironment))	{

		if ( ERROR_SUCCESS == RegQueryValueEx(
			hKeyEnvironment,					// handle to key
			(LPCTSTR)strDDKEnvironmentName,		// value name
			NULL,								// reserved
			&dwType,							// type buffer
			(LPBYTE)g_bufDDKPath,				// data buffer
			&dwBufLen))							// size of data buffer
		{

		}
		RegCloseKey(hKeyEnvironment);
	}
}

BOOL CEasySYSDlg::CheckDDKEnvironment()
{
	TCHAR bufDDKPath[MAX_PATH];
	CString strDDKEnvironmentName = m_strDDKVer + _T("BASE");
	DWORD dwBufLen = MAX_PATH;
	DWORD dwType = REG_SZ;
	BOOL bRet = FALSE;
	HKEY hKeyEnvironment;

	//check system Environment
	if(ERROR_SUCCESS == RegOpenKeyEx(HKEY_LOCAL_MACHINE, ENVIRONMENT_PATH_SYSTEM, 0, KEY_READ, &hKeyEnvironment))
	{
		if ( ERROR_SUCCESS == RegQueryValueEx(hKeyEnvironment,(LPCTSTR)strDDKEnvironmentName,NULL,&dwType,(LPBYTE)bufDDKPath,&dwBufLen) )
		{
			bRet = TRUE;
		}
		RegCloseKey(hKeyEnvironment);
	}
	if (bRet)
	{
		return bRet;
	}

	//check user's Environment
	dwBufLen = MAX_PATH;
	if(ERROR_SUCCESS == RegOpenKeyEx(HKEY_CURRENT_USER, ENVIRONMENT_PATH_USER, 0, KEY_READ, &hKeyEnvironment))
	{
		if ( ERROR_SUCCESS != RegQueryValueEx(hKeyEnvironment,(LPCTSTR)strDDKEnvironmentName,NULL,&dwType,(LPBYTE)bufDDKPath,&dwBufLen) )
		{
			//check ddk install
			CString strDDKLocation;
			int nRet = GetDDKLocation(strDDKLocation);
			if (nRet == 0)
			{
				CString strTemp;
				strTemp.Format(_T("You have not installed DDK!"));
				MessageBox(strTemp, DIALOG_CAPTION);
				return FALSE;
			}
			else if (nRet > 1 )
			{
				CString strTemp;
				strTemp.Format(_T("You have installed more than one DDK. \nWe Use the \"%s\" as default DDK."), strDDKLocation);
				MessageBox(strTemp, DIALOG_CAPTION);
			}

			//set ddk
			CString strTXT;
			strTXT.Format(_T("DDKBuild need environment named %s.\nDo you want to let me set it now?"), strDDKEnvironmentName);

			int iRet = MessageBox(strTXT, DIALOG_CAPTION ,MB_YESNO);
			if (iRet == IDYES)
			{
				// !!ΪűEѾsetEԲuser environment
				bRet = SetDDKEnvironment(strDDKLocation);
				if (!bRet)
				{
					MessageBox(_T("Set DDK Environment Error!"), DIALOG_CAPTION ,MB_YESNO);
				}
			}
		}
		else
		{
			bRet = TRUE;
		}

		RegCloseKey(hKeyEnvironment);
	}
	return bRet;
}

BOOL CEasySYSDlg::SetDDKEnvironment(CString &strDDKEnvironmentValue)
{
	//set user's ddk Environment

	CString strDDKEnvironmentName = m_strDDKVer + _T("BASE");
	BOOL bRet = FALSE;
	HKEY hKeyEnvironment;
	DWORD dwType = REG_SZ;

	if(ERROR_SUCCESS == RegOpenKeyEx(HKEY_CURRENT_USER, ENVIRONMENT_PATH_USER, 0, KEY_WRITE, &hKeyEnvironment))
	{
		if ( ERROR_SUCCESS == RegSetValueEx(hKeyEnvironment,strDDKEnvironmentName,0,dwType,(LPBYTE)strDDKEnvironmentValue.GetBuffer(0),strDDKEnvironmentValue.GetLength()) )
		{
			bRet = TRUE;
			::SendMessage(HWND_BROADCAST,WM_SETTINGCHANGE,0,(LPARAM)TEXT("environment"));
		}
		RegCloseKey(hKeyEnvironment);
	}
	return bRet;
}

int CEasySYSDlg::CreateSysProject()
{
	UpdateData();
	CString strPrjBaseDir = m_strPrjPath;

	if (strPrjBaseDir.Right(1) != _T("\\") )
	{
		strPrjBaseDir += _T("\\");
	}

	strPrjBaseDir += m_strPrjName;

	// Create project directory
	if (!CreateDirectory(strPrjBaseDir, NULL))
	{
		if (ERROR_ALREADY_EXISTS != GetLastError())
		{
			MessageBox(_T("Can not create project directory."),
				DIALOG_CAPTION, MB_ICONSTOP);
			return -1;
		}
	}
	strPrjBaseDir += _T("\\");

	// upper case project name
	CString strProjectNameU = m_strPrjName;
	strProjectNameU.MakeUpper();

	// upper case first character of project name, do not needed?
	CString strProjectNameA = m_strPrjName;
	strProjectNameA.MakeLower();
	strProjectNameA.SetAt(0, toupper(m_strPrjName[0]));

	// 1. create .sln
	CString strDSWFileName = strPrjBaseDir + m_strPrjName;
	strDSWFileName += _T(".sln");

	CFileFind fFind;
	if (fFind.FindFile(strDSWFileName))
	{
		// project already exist
		DWORD ret = MessageBox(_T("Sys Project files already exist, overwrite?"),
			DIALOG_CAPTION, MB_YESNO|MB_ICONQUESTION);
		if ( ret == IDNO ) return -3;
	}

	// 
	// GUID -- $(PROJECT_SDNUM)
	// eg: CD8D2DAE-6817-43A7-B398-3F90E24756CE
	// 
	// --sudami 08/08/13

	CString szGUID = GenerateRandomStrings(8);
	szGUID += _T("-");
	szGUID += GenerateRandomStrings(4);
	szGUID += _T("-");
	szGUID += GenerateRandomStrings(4);
	szGUID += _T("-");
	szGUID += GenerateRandomStrings(4);
	szGUID += _T("-");
	szGUID += GenerateRandomStrings(12);

	CFile file;

	if (TYPE_VS2005 == nIDEtype)
	{
		CString strDSWFileContent = LoadText(MAKEINTRESOURCE(IDR_SLN));
		// replace
		strDSWFileContent.Replace(_T("$(PROJECT_NAME)"), m_strPrjName);
		strDSWFileContent.Replace(_T("$(PROJECT_SDNUM)"), szGUID);

		if (!file.Open(strDSWFileName, CFile::modeCreate | CFile::modeWrite))
		{
			return -2;
		}

		file.Write(strDSWFileContent,(strDSWFileContent.GetLength()) * sizeof(TCHAR));
		file.Close();
	}
	else if(TYPE_VS2008 == nIDEtype)
	{
		CString strDSWFileContent =LoadText(MAKEINTRESOURCE(IDR_SLN2008));
		// replace
		strDSWFileContent.Replace(_T("$(PROJECT_NAME)"), m_strPrjName);
		strDSWFileContent.Replace(_T("$(PROJECT_SDNUM)"), szGUID);

		if (!file.Open(strDSWFileName, CFile::modeCreate | CFile::modeWrite))
		{
			return -2;
		}

		file.Write(strDSWFileContent,(strDSWFileContent.GetLength()) * sizeof(TCHAR));
		file.Close();
	}
	
	// 2rd, create .vcproj file
	CString strvcprojName = strPrjBaseDir + m_strPrjName;
	strvcprojName += _T(".vcproj");

	if (!file.Open(strvcprojName, CFile::modeCreate | CFile::modeWrite))
	{
		return -2;
	}

	if (TYPE_VS2005 == nIDEtype)
	{
		CString strvcprojContent = LoadText(MAKEINTRESOURCE(IDR_VCPROJ));
		strvcprojContent.Replace(_T("$(PROJECT_NAME)"), m_strPrjName);
		strvcprojContent.Replace(_T("$(PROJECT_SDNUM)"), szGUID);

		file.Write(strvcprojContent, (strvcprojContent.GetLength() ) * sizeof(TCHAR));
		file.Close();
	}
	else if(TYPE_VS2008 == nIDEtype)
	{
		CString strvcprojContent = LoadText(MAKEINTRESOURCE(IDR_VCPROJ2008));
		strvcprojContent.Replace(_T("$(PROJECT_NAME)"), m_strPrjName);
		strvcprojContent.Replace(_T("$(PROJECT_SDNUM)"), szGUID);

		file.Write(strvcprojContent, (strvcprojContent.GetLength() ) * sizeof(TCHAR));
		file.Close();
	}

	// 3rd, create .c file
	CString strCFileName = strPrjBaseDir + m_strPrjName;
	strCFileName += _T(".c");
	if (!file.Open(strCFileName, CFile::modeCreate | CFile::modeWrite))
	{
		return -2;
	}

	CString strCFileContent = LoadText(MAKEINTRESOURCE(IDR_CFILE));
	strCFileContent.Replace(_T("$(PROJECT_NAME)"), m_strPrjName);
	strCFileContent.Replace(_T("$(PROJECT_NAME_U)"), strProjectNameU);
	strCFileContent.Replace(_T("$(PROJECT_NAME_A)"), strProjectNameA);
	//Add by ChiChou
	strCFileContent.Replace(_T("$(INFO_DATE)"), m_strDate);
	strCFileContent.Replace(_T("$(INFO_AUTHOR)"), m_strPrjAuthor);
	strCFileContent.Replace(_T("$(INFO_COMMENT)"), m_strPrjComment);

	file.Write(strCFileContent, (strCFileContent.GetLength() ) * sizeof(TCHAR));
	file.Close();

	// 4th, create .h file
	CString strHFileName = strPrjBaseDir + m_strPrjName;
	strHFileName += _T(".h");
	if (!file.Open(strHFileName, CFile::modeCreate | CFile::modeWrite))
	{
		return -2;
	}

	CString strHFileContent = LoadText(MAKEINTRESOURCE(IDR_HFILE));
	strHFileContent.Replace(_T("$(PROJECT_NAME)"), m_strPrjName);
	strHFileContent.Replace(_T("$(PROJECT_NAME_U)"), strProjectNameU);
	strHFileContent.Replace(_T("$(PROJECT_NAME_A)"), strProjectNameA);
	//Add by ChiChou
	strHFileContent.Replace(_T("$(INFO_DATE)"), m_strDate);
	strHFileContent.Replace(_T("$(INFO_AUTHOR)"), m_strPrjAuthor);
	strHFileContent.Replace(_T("$(INFO_COMMENT)"), m_strPrjComment);

	file.Write(strHFileContent, (strHFileContent.GetLength() ) * sizeof(TCHAR));
	file.Close();

	// 5th, create readme.txt
	CString strReadmeFileName = strPrjBaseDir + _T("readme.txt");
	if (!file.Open(strReadmeFileName, CFile::modeCreate | CFile::modeWrite))
	{
		return -2;
	}

	CString strReadmeFileContent = LoadText(MAKEINTRESOURCE(IDR_README));
	
	file.Write(strReadmeFileContent, (strReadmeFileContent.GetLength() ) * sizeof(TCHAR));
	file.Close();

	// 6th, create recoures
	CString strSourcesFileName = strPrjBaseDir + _T("sources");

	if (!file.Open(strSourcesFileName, CFile::modeCreate | CFile::modeWrite))
	{
		return -2;
	}

	CString strSourcesFileContent;
	strSourcesFileContent = LoadText(MAKEINTRESOURCE(IDR_SOURCES));
	strSourcesFileContent.Replace(_T("$(PROJECT_NAME)"), m_strPrjName);
	
	file.Write(strSourcesFileContent, (strSourcesFileContent.GetLength() ) * sizeof(TCHAR));
	file.Close();
	
	// 7th, create makefile
	CString strMakefileFileName = strPrjBaseDir + _T("makefile");

	if (!file.Open(strMakefileFileName, CFile::modeCreate | CFile::modeWrite))
	{
		return -2;
	}

	CString strMakefileFileContent;
	strMakefileFileContent = LoadText(MAKEINTRESOURCE(IDR_MAKEFILE));
	strMakefileFileContent.Replace(_T("$(PROJECT_NAME)"), m_strPrjName);
	
	file.Write(strMakefileFileContent, (strMakefileFileContent.GetLength() ) * sizeof(TCHAR));
	file.Close();

	// 8th, create ddkbuild.cmd
	CString strDDKBuildFileName = strPrjBaseDir + _T("ddkbuild.cmd");
	if (!file.Open(strDDKBuildFileName, CFile::modeCreate | CFile::modeWrite))
	{
		return -2;
	}
	
	CString strDDKBuildFileContent;
	strDDKBuildFileContent = LoadText(MAKEINTRESOURCE(IDR_DDKBUILD_BAT));
	
	file.Write(strDDKBuildFileContent, (strDDKBuildFileContent.GetLength() ) * sizeof(TCHAR));
	file.Close();

	// 9th, create struct.h file
	strHFileName = strPrjBaseDir + _T("struct.h");
	if (!file.Open(strHFileName, CFile::modeCreate | CFile::modeWrite))
	{
		return -2;
	}
	
	strHFileContent = LoadText(MAKEINTRESOURCE(IDR_STRUCT_H));
	//Add by ChiChou
	strHFileContent.Replace(_T("$(INFO_DATE)"), m_strDate);
	strHFileContent.Replace(_T("$(INFO_AUTHOR)"), m_strPrjAuthor);
	strHFileContent.Replace(_T("$(INFO_COMMENT)"), m_strPrjComment);
	
	file.Write(strHFileContent, (strHFileContent.GetLength()) * sizeof(TCHAR));
	file.Close();

	// 10th, create mybuild.bat
	CString strMyBuildFileName = strPrjBaseDir + _T("mybuild.bat");

	if (!file.Open(strMyBuildFileName, CFile::modeCreate | CFile::modeWrite))
	{
		return -2;
	}

	//strmyBuildFileContent.Replace(_T("$(PROJECT_DDKPATH)"),
	//	/*g_bufDDKPath*/_T("C:\\WINDDK\\3790.1830"));	

	CString strmyBuildFileContent = LoadText(MAKEINTRESOURCE(IDR_MYBUILD));
	strmyBuildFileContent.Replace(_T("$(PROJECT_MYBUILD_CMD_LINE)"), g_bufBuildLine);
//	strmyBuildFileContent.Replace(_T("$(PROJECT_DDKPATH)"),g_bufDDKPath);
//	strmyBuildFileContent.Replace(_T("$(PROJECT_ENVIRONMENT)"),g_strDDKVer);
//	strmyBuildFileContent.Replace(_T("$(PROJECT_OTHER_PARAM)"),g_strOtherParam);

	file.Write(strmyBuildFileContent, (strmyBuildFileContent.GetLength()) * sizeof(TCHAR));
	file.Close();

	//Add by ChiChou
	// 11th, create clean.bat
	CString strCleanBatFileName = strPrjBaseDir + _T("clean.bat");
	CString strCleanBat = LoadText(MAKEINTRESOURCE(IDR_CLEAN));

	if (!file.Open(strCleanBatFileName, CFile::modeCreate | CFile::modeWrite))
	{
		return -2;
	}
	file.Write(strCleanBat, (strCleanBat.GetLength()) * sizeof(TCHAR));
	file.Close();

	// 12th, create common.h file
	CString strCommonName = strPrjBaseDir + _T("common.h");
	if (!file.Open(strCommonName, CFile::modeCreate | CFile::modeWrite))
	{
		return -2;
	}
	
	CString strCommonContent = LoadText(MAKEINTRESOURCE(IDR_COMMON_H));
	strCommonContent.Replace(_T("$(PROJECT_NAME)"), m_strPrjName);
	strCommonContent.Replace(_T("$(PROJECT_NAME_U)"), strProjectNameU);
	strCommonContent.Replace(_T("$(PROJECT_NAME_A)"), strProjectNameA);	

	strCommonContent.Replace(_T("$(INFO_DATE)"), m_strDate);
	strCommonContent.Replace(_T("$(INFO_AUTHOR)"), m_strPrjAuthor);
	strCommonContent.Replace(_T("$(INFO_COMMENT)"), m_strPrjComment);
	
	file.Write(strCommonContent, (strCommonContent.GetLength()) * sizeof(TCHAR));
	file.Close();

//////////////////////////////////////////////////////////////////////////

	//Finish
	return 0;
}

int CEasySYSDlg::CreateSysProject_vc6()
{
	UpdateData();
	CString strPrjBaseDir = m_strPrjPath;

	if (strPrjBaseDir.Right(1) !=  _T("\\"))
	{
		strPrjBaseDir +=  _T("\\");
	}

	strPrjBaseDir += m_strPrjName;

	if (!CreateDirectory(strPrjBaseDir, NULL))
	{
		if (ERROR_ALREADY_EXISTS != GetLastError())
		{
			MessageBox(_T("Can not create project directory."),
				DIALOG_CAPTION, MB_ICONSTOP);
			return -1;
		}
	}

	strPrjBaseDir += _T("\\");

	// upper case project name
	CString strProjectNameU = m_strPrjName;
	strProjectNameU.MakeUpper();

	// upper case first character of project name, not needed?
	CString strProjectNameA = m_strPrjName;
	strProjectNameA.MakeLower();
	strProjectNameA.SetAt(0, toupper(m_strPrjName[0]));

	// frist create .dsw
	CString strDSWFileName = strPrjBaseDir + m_strPrjName;
	strDSWFileName += _T(".dsw");
	
	CFileFind fFind;

	if (fFind.FindFile(strDSWFileName))
	{
		// project already exist
		DWORD ret = MessageBox(_T("Sys Project files already exist, overwrite?"),
			DIALOG_CAPTION, MB_YESNO|MB_ICONQUESTION);
		if ( ret == IDNO )
		{
			return -3;
		}
	}

	CFile file;
	CString strDSWFileContent = LoadText(MAKEINTRESOURCE(IDR_DSW));
	strDSWFileContent.Replace(_T("$(PROJECT_NAME)"), m_strPrjName);

	if (!file.Open(strDSWFileName, CFile::modeCreate | CFile::modeWrite))
	{
		return -2;
	}

	file.Write(strDSWFileContent, (strDSWFileContent.GetLength() ) * sizeof(TCHAR));
	file.Close();

	// 2nd, create .dsp
	int iProjectCount = 0;
	CString strDSPFileName = strPrjBaseDir + m_strPrjName;
	strDSPFileName += _T(".dsp");
	
	if (!file.Open(strDSPFileName, CFile::modeCreate | CFile::modeWrite))
	{
		return -2;
	}

	CString strDSPFileContent = LoadText(MAKEINTRESOURCE(IDR_DSP));
	CString strProjectConfigNames;
	CString strProjectConfigs;
	CString strProjectConfigName2s;

	int nIndex;
	int i = 0;
	//count for the project,  it's useful in the first project and last project
	while( (nIndex = GetCheckItem(TARGET_OS, i)) != -1)
	{
		iProjectCount++;
		//create $(PROJECT_CONFIG_NAME) in dsp
		CString strProjectConfigName = LoadText(MAKEINTRESOURCE(IDR_DSP_PROJECT_CONFIG_NAME));
		strProjectConfigName.Replace(_T("$(TARGET_OS)"), g_options[nIndex].szInter);
		strProjectConfigNames += strProjectConfigName;

		//create $(PROJECT_CONFIG) in dsp
		CString strProjectConfig = LoadText(MAKEINTRESOURCE(IDR_DSP_PROJECT_CONFIG));
		strProjectConfig.Replace(_T("$(TARGET_OS)"), g_options[nIndex].szInter);
		
		//when the ddk is same as target os, such as WNETWNET, convert to WNET
		if (m_strDDKVer.CollateNoCase(g_options[nIndex].szInter) == 0)
		{
			strProjectConfig.Replace(_T("$(DDK_VER)"), _T(""));
		}
		else
		{
			strProjectConfig.Replace(_T("$(DDK_VER)"), m_strDDKVer);
		}
		
		if (iProjectCount == 1)
		{
			strProjectConfig.Replace(_T("$(IF_FLAG)"), _T("!IF"));
			strDSPFileContent.Replace(_T("$(DEFAULT_TARGET_OS)"), g_options[nIndex].szInter);
		}
		else
		{
			strProjectConfig.Replace(_T("$(IF_FLAG)"), _T("!ELSEIF"));
		}

		if (iProjectCount == m_nTosNum)
		{
			strProjectConfig.Replace(_T("$(ENDIF_FLAG)"), _T("!ENDIF"));
		}
		else
		{
			strProjectConfig.Replace(_T("$(ENDIF_FLAG)"), _T(""));
		}

		strProjectConfigs += strProjectConfig;
		
		//create $(PROJECT_CONFIG_NAME_2)
		CString strProjectConfigName2 =  LoadText(MAKEINTRESOURCE(IDR_DSP_PROJECT_CONFIG_NAME_2));
		strProjectConfigName2.Replace(_T("$(TARGET_OS)"), g_options[nIndex].szInter);
		strProjectConfigName2s += strProjectConfigName2;

		i++;

	}

	strDSPFileContent.Replace(_T("$(PROJECT_CONFIG_NAME)"), strProjectConfigNames);
	strDSPFileContent.Replace(_T("$(PROJECT_CONFIG)"), strProjectConfigs);
	strDSPFileContent.Replace(_T("$(PROJECT_CONFIG_NAME_2)"), strProjectConfigName2s);
	//ReplaceInString(strDSPFileContent, "$(SOFTICE_FILE_PATH)", strNMsym);
	strDSPFileContent.Replace(_T("$(PROJECT_NAME)"), m_strPrjName);

	file.Write(strDSPFileContent, (strDSPFileContent.GetLength() ) * sizeof(TCHAR));
	file.Close();
	
	// 3rd, create .c file
	CString strCFileName = strPrjBaseDir + m_strPrjName;
	strCFileName += _T(".c");

	if (!file.Open(strCFileName, CFile::modeCreate | CFile::modeWrite))
	{
		return -2;
	}

	CString strCFileContent;
	strCFileContent = LoadText(MAKEINTRESOURCE(IDR_CFILE));
	strCFileContent.Replace(_T("$(PROJECT_NAME)"), m_strPrjName);
	strCFileContent.Replace(_T("$(PROJECT_NAME_U)"), strProjectNameU);
	strCFileContent.Replace(_T("$(PROJECT_NAME_A)"), strProjectNameA);	
	//Add by ChiChou
	strCFileContent.Replace(_T("$(INFO_DATE)"), m_strDate);
	strCFileContent.Replace(_T("$(INFO_AUTHOR)"), m_strPrjAuthor);
	strCFileContent.Replace(_T("$(INFO_COMMENT)"), m_strPrjComment);
	
	file.Write(strCFileContent, (strCFileContent.GetLength() ) * sizeof(TCHAR));
	file.Close();

	// 4th, create .h file
	CString strHFileName = strPrjBaseDir + m_strPrjName;
	strHFileName += _T(".h");

	if (!file.Open(strHFileName, CFile::modeCreate | CFile::modeWrite))
	{
		return -2;
	}

	CString strHFileContent;
	strHFileContent = LoadText(MAKEINTRESOURCE(IDR_HFILE));
	strHFileContent.Replace(_T("$(PROJECT_NAME)"), m_strPrjName);
	strHFileContent.Replace(_T("$(PROJECT_NAME_U)"), strProjectNameU);
	strHFileContent.Replace(_T("$(PROJECT_NAME_A)"), strProjectNameA);	
	//Add by ChiChou
	strHFileContent.Replace(_T("$(INFO_DATE)"), m_strDate);
	strHFileContent.Replace(_T("$(INFO_AUTHOR)"), m_strPrjAuthor);
	strHFileContent.Replace(_T("$(INFO_COMMENT)"), m_strPrjComment);
	
	file.Write(strHFileContent, (strHFileContent.GetLength() ) * sizeof(TCHAR));
	file.Close();

	// 5th, create readme.txt
	CString strReadmeFileName = strPrjBaseDir + _T("readme.txt");
	if (!file.Open(strReadmeFileName, CFile::modeCreate | CFile::modeWrite))
	{
		return -2;
	}

	CString strReadmeFileContent;
	strReadmeFileContent = LoadText(MAKEINTRESOURCE(IDR_README));
	strReadmeFileContent.Replace(_T("$(PROJECT_NAME)"), m_strPrjName);
	strReadmeFileContent.Replace(_T("$(PROJECT_NAME_U)"), strProjectNameU);

	file.Write(strReadmeFileContent, (strReadmeFileContent.GetLength() ) * sizeof(TCHAR));
	file.Close();

	// 6th, create recoures
	CString strSourcesFileName = strPrjBaseDir + _T("sources");
	if (!file.Open(strSourcesFileName, CFile::modeCreate | CFile::modeWrite))
	{
		return -2;
	}

	CString strSourcesFileContent;
	strSourcesFileContent = LoadText(MAKEINTRESOURCE(IDR_SOURCES));
	strSourcesFileContent.Replace(_T("$(PROJECT_NAME)"), m_strPrjName);
	
	file.Write(strSourcesFileContent, (strSourcesFileContent.GetLength() ) * sizeof(TCHAR));
	file.Close();
	
	// 7th, create makefile
	CString strMakefileFileName = strPrjBaseDir + _T("makefile");
	if (!file.Open(strMakefileFileName, CFile::modeCreate | CFile::modeWrite))
	{
		return -2;
	}

	CString strMakefileFileContent;
	strMakefileFileContent = LoadText(MAKEINTRESOURCE(IDR_MAKEFILE));
	strMakefileFileContent.Replace(_T("$(PROJECT_NAME)"), m_strPrjName);
	
	file.Write(strMakefileFileContent, (strMakefileFileContent.GetLength() ) * sizeof(TCHAR));
	file.Close();

// 	// 8th, create ddkbuild.bat
// 	CString strDDKBuildFileName = strPrjBaseDir + _T("ddkbuild.bat");
// 	if (!file.Open(strDDKBuildFileName, CFile::modeCreate | CFile::modeWrite))
// 	{
// 		return -2;
// 	}
// 	
// 	CString strDDKBuildFileContent;
// 	strDDKBuildFileContent = LoadText(MAKEINTRESOURCE(IDR_DDKBUILD_VC6));
// 	strDDKBuildFileContent.Replace(_T("$(PROJECT_NAME)"), m_strPrjName);
// 	
// 	file.Write(strDDKBuildFileContent, (strDDKBuildFileContent.GetLength() ) * sizeof(TCHAR));
// 	file.Close();

	// 8th, create ddkbuild.cmd
	CString strDDKBuildFileName = strPrjBaseDir + _T("ddkbuild.cmd");
	if (!file.Open(strDDKBuildFileName, CFile::modeCreate | CFile::modeWrite))
	{
		return -2;
	}
	
	CString strDDKBuildFileContent;
	strDDKBuildFileContent = LoadText(MAKEINTRESOURCE(IDR_DDKBUILD_BAT));
	
	file.Write(strDDKBuildFileContent, (strDDKBuildFileContent.GetLength() ) * sizeof(TCHAR));
	file.Close();

//////////////////////////////////////////////////////////////////////////




	// 9th, create struct.h file
	strHFileName = strPrjBaseDir + _T("struct.h");

	if (!file.Open(strHFileName, CFile::modeCreate | CFile::modeWrite))
	{
		return -2;
	}	

	strHFileContent = LoadText(MAKEINTRESOURCE(IDR_STRUCT_H));	
	//Add by ChiChou
	strHFileContent.Replace(_T("$(INFO_DATE)"), m_strDate);
	strHFileContent.Replace(_T("$(INFO_AUTHOR)"), m_strPrjAuthor);
	strHFileContent.Replace(_T("$(INFO_COMMENT)"), m_strPrjComment);

	file.Write(strHFileContent, (strHFileContent.GetLength() ) * sizeof(TCHAR));
	file.Close();

	// 10th, create mybuild_vc6.bat
	CString strMyBuildFileName = strPrjBaseDir + _T("mybuild.bat");

	if (!file.Open(strMyBuildFileName, CFile::modeCreate | CFile::modeWrite))
	{
		return -2;
	}
	
	CString strmyBuildFileContent = LoadText(MAKEINTRESOURCE(IDR_MYBUILD_VC6));
	strmyBuildFileContent.Replace(_T("$(PROJECT_MYBUILD_CMD_LINE)"), g_bufBuildLine);
//	strmyBuildFileContent.Replace(_T("$(PROJECT_DDKPATH)"),g_bufDDKPath);
//	strmyBuildFileContent.Replace(_T("$(PROJECT_ENVIRONMENT)"),g_strDDKVer);
//	strmyBuildFileContent.Replace(_T("$(PROJECT_OTHER_PARAM)"),g_strOtherParam);

	file.Write(strmyBuildFileContent, (strmyBuildFileContent.GetLength()) * sizeof(TCHAR));
	file.Close();

	// 11th, create clean.bat
	CString strCleanBatFileName = strPrjBaseDir + _T("clean.bat");
	CString strCleanBat = LoadText(MAKEINTRESOURCE(IDR_CLEAN));
	
	if (!file.Open(strCleanBatFileName, CFile::modeCreate | CFile::modeWrite))
	{
		return -2;
	}
	file.Write(strCleanBat, (strCleanBat.GetLength()) * sizeof(TCHAR));
	file.Close();

	// 12th, create common.h file
	CString strCommonName = strPrjBaseDir + _T("common.h");
	if (!file.Open(strCommonName, CFile::modeCreate | CFile::modeWrite))
	{
		return -2;
	}
	
	CString strCommonContent = LoadText(MAKEINTRESOURCE(IDR_COMMON_H));
	strCommonContent.Replace(_T("$(PROJECT_NAME)"), m_strPrjName);
	strCommonContent.Replace(_T("$(PROJECT_NAME_U)"), strProjectNameU);
	strCommonContent.Replace(_T("$(PROJECT_NAME_A)"), strProjectNameA);	

	strCommonContent.Replace(_T("$(INFO_DATE)"), m_strDate);
	strCommonContent.Replace(_T("$(INFO_AUTHOR)"), m_strPrjAuthor);
	strCommonContent.Replace(_T("$(INFO_COMMENT)"), m_strPrjComment);
	
	file.Write(strCommonContent, (strCommonContent.GetLength()) * sizeof(TCHAR));
	file.Close();

//////////////////////////////////////////////////////////////////////////
	return 0;
}

int CEasySYSDlg::CreateConsoleProject()
{
	UpdateData();
	CString strPrjBaseDir = m_strPrjPath;

	if (strPrjBaseDir.Right(1) != _T("\\") )
	{
		strPrjBaseDir += _T("\\");
	}

	strPrjBaseDir += m_strPrjName;

	strPrjBaseDir += (_T("\\") + m_strPrjName + _T("App"));

	// Create project directory
	if (!CreateDirectory(strPrjBaseDir, NULL))
	{
		if (ERROR_ALREADY_EXISTS != GetLastError())
		{
			MessageBox(_T("Can not create project directory."),
				DIALOG_CAPTION, MB_ICONSTOP);
			return -1;
		}
	}
	strPrjBaseDir += _T("\\");

	// upper case project name
	CString strProjectNameU = m_strPrjName + _T("App");
	strProjectNameU.MakeUpper();

	// upper case first character of project name, do not needed?
	CString strProjectNameA = m_strPrjName + _T("App");
	strProjectNameA.MakeLower();
	strProjectNameA.SetAt(0, toupper(m_strPrjName[0]));

	// 1st. create .sln
	CString strDSWFileName = strPrjBaseDir + m_strPrjName + _T("App");
	strDSWFileName += _T(".sln");

	CFileFind fFind;
	if (fFind.FindFile(strDSWFileName))
	{
		// project already exist
		DWORD ret = MessageBox(_T("Console Project files already exist, overwrite?"),
			DIALOG_CAPTION, MB_YESNO|MB_ICONQUESTION);
		if ( ret == IDNO ) return -3;
	}

	// 
	// GUID -- $(PROJECT_SDNUM)
	// eg: CD8D2DAE-6817-43A7-B398-3F90E24756CE
	// 
	// --sudami 08/08/13

	CString szGUID = GenerateRandomStrings(8);
	szGUID += _T("-");
	szGUID += GenerateRandomStrings(4);
	szGUID += _T("-");
	szGUID += GenerateRandomStrings(4);
	szGUID += _T("-");
	szGUID += GenerateRandomStrings(4);
	szGUID += _T("-");
	szGUID += GenerateRandomStrings(12);

	CFile file;

	if (TYPE_VS2005 == nIDEtype)
	{
		CString strDSWFileContent = LoadText(MAKEINTRESOURCE(IDR_CONSOLE_SLN));
		// replace
		strDSWFileContent.Replace(_T("$(PROJECT_NAME)"), m_strPrjName + _T("App"));
		strDSWFileContent.Replace(_T("$(PROJECT_SDNUM)"), szGUID);

		if (!file.Open(strDSWFileName, CFile::modeCreate | CFile::modeWrite))
		{
			return -2;
		}

		file.Write(strDSWFileContent,(strDSWFileContent.GetLength()) * sizeof(TCHAR));
		file.Close();
	}
	else if(TYPE_VS2008 == nIDEtype)
	{
		CString strDSWFileContent = LoadText(MAKEINTRESOURCE(IDR_EXESLN2008));
		// replace
		strDSWFileContent.Replace(_T("$(PROJECT_NAME)"), m_strPrjName + _T("App"));
		strDSWFileContent.Replace(_T("$(PROJECT_SDNUM)"), szGUID);

		if (!file.Open(strDSWFileName, CFile::modeCreate | CFile::modeWrite))
		{
			return -2;
		}

		file.Write(strDSWFileContent,(strDSWFileContent.GetLength()) * sizeof(TCHAR));
		file.Close();
	}

	// 2nd, create .vcproj file
	CString strvcprojName = strPrjBaseDir + m_strPrjName + _T("App");
	strvcprojName += _T(".vcproj");

	if (!file.Open(strvcprojName, CFile::modeCreate | CFile::modeWrite))
	{
		return -2;
	}

	if (TYPE_VS2005 == nIDEtype)
	{
		CString strvcprojContent = LoadText(MAKEINTRESOURCE(IDR_CONSOLE_VCPROJ));
		strvcprojContent.Replace(_T("$(PROJECT_NAME)"), m_strPrjName + _T("App"));
		strvcprojContent.Replace(_T("$(PROJECT_SDNUM)"), szGUID);

		file.Write(strvcprojContent, (strvcprojContent.GetLength() ) * sizeof(TCHAR));
		file.Close();
	}
	else if(TYPE_VS2008 == nIDEtype)
	{
		CString strvcprojContent = LoadText(MAKEINTRESOURCE(IDR_CONSOLE_VCPROJ2008));
		strvcprojContent.Replace(_T("$(PROJECT_NAME)"), m_strPrjName + _T("App"));
		strvcprojContent.Replace(_T("$(PROJECT_SDNUM)"), szGUID);

		file.Write(strvcprojContent, (strvcprojContent.GetLength() ) * sizeof(TCHAR));
		file.Close();
	}

	// 3rd, create XXApp.cpp file
	CString strConsoleMainName = strPrjBaseDir + m_strPrjName + _T("App");
	strConsoleMainName += _T(".cpp");
	if (!file.Open(strConsoleMainName, CFile::modeCreate | CFile::modeWrite))
	{
		return -2;
	}

	CString strConsoleMainContent = LoadText(MAKEINTRESOURCE(IDR_CONSOLE_MAIN));
	strConsoleMainContent.Replace(_T("$(PROJECT_NAME)"), m_strPrjName + _T("App"));
	strConsoleMainContent.Replace(_T("$(PROJECT_NAME_U)"), strProjectNameU);
	strConsoleMainContent.Replace(_T("$(PROJECT_NAME_A)"), strProjectNameA);
	strConsoleMainContent.Replace(_T("$(SYS_FILENAME)"), m_strPrjName + _T(".sys"));
	strConsoleMainContent.Replace(_T("$(SYS_NAME)"), m_strPrjName);
	
	//Add by ChiChou
	strConsoleMainContent.Replace(_T("$(INFO_DATE)"), m_strDate);
	strConsoleMainContent.Replace(_T("$(INFO_AUTHOR)"), m_strPrjAuthor);
	strConsoleMainContent.Replace(_T("$(INFO_COMMENT)"), m_strPrjComment);

	file.Write(strConsoleMainContent, (strConsoleMainContent.GetLength() ) * sizeof(TCHAR));
	file.Close();

	// 4th, create stdafx.cpp file
	CString strStdafxName = strPrjBaseDir + _T("stdafx.cpp");
	if (!file.Open(strStdafxName, CFile::modeCreate | CFile::modeWrite))
	{
		return -2;
	}

	CString strStdafxContent = LoadText(MAKEINTRESOURCE(IDR_CONSOLE_STDAFXCPP));
	file.Write(strStdafxContent, (strStdafxContent.GetLength() ) * sizeof(TCHAR));
	file.Close();

	// 5th, create stdafx.h file
	CString strStdafxHName = strPrjBaseDir + _T("stdafx.h");
	if (!file.Open(strStdafxHName, CFile::modeCreate | CFile::modeWrite))
	{
		return -2;
	}

	CString strStdafxHContent = LoadText(MAKEINTRESOURCE(IDR_CONSOLE_STDAFXH));
	file.Write(strStdafxHContent, (strStdafxHContent.GetLength() ) * sizeof(TCHAR));
	file.Close();

//*****************************************************************************
	// Create project directory (XXApp\bakSrc) 
	if (!CreateDirectory((strPrjBaseDir + _T("bakSrc")), NULL))
	{
		if (ERROR_ALREADY_EXISTS != GetLastError())
		{
			MessageBox(_T("Can not create project directory."),
				DIALOG_CAPTION, MB_ICONSTOP);
			return -1;
		}
	}

	// 6th, create LoadNTDriver.h file
 	CString strLoadNTDriverHName = strPrjBaseDir + _T("bakSrc") + _T("\\") + _T("LoadNTDriver.h");
 	if (!file.Open(strLoadNTDriverHName, CFile::modeCreate | CFile::modeWrite))
 	{
 		return -2;
 	}
 
 	CString strLoadNTDriverHContent = LoadText(MAKEINTRESOURCE(IDR_LOADNTDRIVER_H));
 	file.Write(strLoadNTDriverHContent, (strLoadNTDriverHContent.GetLength() ) * sizeof(TCHAR));
	file.Close();

	// 7th, create LoadNTDriver.cpp file
	CString strLoadNTDriverName = strPrjBaseDir + _T("bakSrc") +  _T("\\") + _T("LoadNTDriver.cpp");
	if (!file.Open(strLoadNTDriverName, CFile::modeCreate | CFile::modeWrite))
	{
		return -2;
	}

	CString strLoadNTDriverContent = LoadText(MAKEINTRESOURCE(IDR_LOADNTDRIVER_CPP));
	file.Write(strLoadNTDriverContent, (strLoadNTDriverContent.GetLength() ) * sizeof(TCHAR));
	file.Close();

	return 0;
}

int CEasySYSDlg::CreateConsoleProject_vc6()
{
	return 0;
}

//////////////////////////////////////////////////////////////////////////
CString LoadText(LPCTSTR lpName)
{
	CString strText;
	HRSRC hRsrc;
	
	hRsrc = FindResource(AfxGetInstanceHandle(), lpName, RT_HTML);
	HGLOBAL hMem = LoadResource(AfxGetInstanceHandle(), hRsrc);
	DWORD dwSize = SizeofResource(AfxGetInstanceHandle(), hRsrc);
	TCHAR *src = (TCHAR*)LockResource(hMem);
	strText.Format(_T("%s"),src);

	return strText;
}

CString LoadTextById(int ID)
{
	CString strText;
	HRSRC hRsrc;	

	hRsrc = FindResource(AfxGetInstanceHandle(), MAKEINTRESOURCE(ID), RT_HTML);
	HGLOBAL hMem = LoadResource(AfxGetInstanceHandle(), hRsrc);
	DWORD dwSize = SizeofResource(AfxGetInstanceHandle(), hRsrc);
	TCHAR *src = (TCHAR*)LockResource(hMem);
	strText.Format(_T("%s"),src);

	return strText;
}

BOOL CEasySYSDlg::SavePathToReg()
{
	BOOL bRet = FALSE;
	HKEY hkey;
	DWORD dwDisposition;

	if (ERROR_SUCCESS == RegCreateKeyEx(HKEY_CURRENT_USER, CONFIG_PATH, NULL, NULL, REG_OPTION_NON_VOLATILE, 
				KEY_ALL_ACCESS, NULL, &hkey, &dwDisposition))
	{
		DWORD dwType = REG_SZ;

		//save path
		if ( ERROR_SUCCESS == RegSetValueEx(hkey,CONFIG_NAME_LOCATION,NULL,dwType,(const BYTE *)m_strPrjPath.GetBuffer(0),m_strPrjPath.GetLength()) )
		{
			bRet = TRUE;
		}

		//save author
		RegSetValueEx(hkey,CONFIG_NAME_AUTHOR,NULL,dwType,(const BYTE *)m_strPrjAuthor.GetBuffer(0),m_strPrjAuthor.GetLength());

		RegCloseKey(hkey);
	}
	return bRet;

}

BOOL CEasySYSDlg::ReadPathFromReg()
{
	BOOL bRet = FALSE;
	HKEY hkey;
	if (ERROR_SUCCESS == RegOpenKeyEx(HKEY_CURRENT_USER, CONFIG_PATH, NULL, KEY_QUERY_VALUE, &hkey))
	{
		DWORD dwType = REG_SZ;
		DWORD dwBufLen = MAX_PATH;

		BYTE bufLocation[MAX_PATH];
		BYTE bufAuthor[MAX_PATH];

		//get path
		if (ERROR_SUCCESS == RegQueryValueEx(hkey,CONFIG_NAME_LOCATION,NULL,&dwType,(LPBYTE)bufLocation,&dwBufLen))
		{
			bRet = TRUE;
			m_strPrjPath = bufLocation;
		}

		//get author
		if (ERROR_SUCCESS == RegQueryValueEx(hkey,CONFIG_NAME_AUTHOR,NULL,&dwType,(LPBYTE)bufAuthor,&dwBufLen))
		{
			m_strPrjAuthor = bufAuthor;
		}

		RegCloseKey(hkey);
	}
	return bRet;
}

int CEasySYSDlg::GetDDKLocation(CString &strDDKLocation)
{
	HKEY hKey;
	DWORD dwIndex = 0;
	if(ERROR_SUCCESS == RegOpenKeyEx(HKEY_LOCAL_MACHINE, WINDDK_PATH, 0, KEY_ENUMERATE_SUB_KEYS, &hKey))
	{
		TCHAR bufName[MAX_PATH];
		while(RegEnumKey(hKey,dwIndex,bufName,MAX_PATH) != ERROR_NO_MORE_ITEMS)
		{
			HKEY hSubKey;
			if (ERROR_SUCCESS == RegOpenKeyEx(hKey, bufName, 0, KEY_READ, &hSubKey))
			{
				DWORD dwType = REG_SZ;
				DWORD dwBufLen = MAX_PATH;
				TCHAR bufDDKPath[MAX_PATH];
				if (ERROR_SUCCESS == RegQueryValueEx(hSubKey,_T("LFNDirectory"),NULL,&dwType,(LPBYTE)bufDDKPath,&dwBufLen))
				{
					strDDKLocation = bufDDKPath;
				}
				RegCloseKey(hSubKey);
			}
			dwIndex++;
		}
		RegCloseKey(hKey);
	}
	return dwIndex;
}

void CEasySYSDlg::OnSelectIdeType() 
{
	type = m_IDEType.GetCurSel();
	
	if(2 == type)
	{
		nIDEtype = TYPE_VS2008;

		((CButton*)GetDlgItem(IDC_CREATETESTAPP))->EnableWindow(TRUE);
		((CButton*)GetDlgItem(IDC_CREATETESTAPP))->SetCheck(2);
	}
	else if(1 == type)
	{
		nIDEtype = TYPE_VS2005;

		((CButton*)GetDlgItem(IDC_CREATETESTAPP))->EnableWindow(TRUE);
		((CButton*)GetDlgItem(IDC_CREATETESTAPP))->SetCheck(1);
	}
	else
	{
		nIDEtype = TYPE_VS6;

		// Test app ֻΪVS2005
		((CButton*)GetDlgItem(IDC_CREATETESTAPP))->EnableWindow(FALSE);
		((CButton*)GetDlgItem(IDC_CREATETESTAPP))->SetCheck(0);
	}
}

void CEasySYSDlg::OnCreateName() 
{
	m_strPrjName = GenerateRandomStrings(4);
	GetDlgItem(IDC_PRJ_NAME)->SetWindowText(m_strPrjName);
}

void CEasySYSDlg::OnCancel()
{
	CEasySYSDlg::OnAppSuspend();
}

LRESULT CEasySYSDlg::OnTrayNotification(WPARAM uID, LPARAM lEvent)
{
	return m_trayIcon.OnTrayNotification(uID, lEvent);
}

void CEasySYSDlg::OnAppOpen() 
{
	ShowWindow(SW_NORMAL);
	SetForegroundWindow();
}

void CEasySYSDlg::OnAppSuspend() 
{
	m_trayIcon.DelIcon();
	CDialog::OnCancel();
}


void CEasySYSDlg::OnSelchangeDdkVersion() 
{
	int nIndex = ((CComboBox *)GetDlgItem(IDC_DDK_VERSION))->GetCurSel();
	int nOptionID = ((CComboBox *)GetDlgItem(IDC_DDK_VERSION))->GetItemData(nIndex);
	
	if (nOptionID == DDK_W2K)
	{
		((CButton*)GetDlgItem(IDC_TOS_W2K))->EnableWindow(TRUE);
		((CButton*)GetDlgItem(IDC_TOS_W2K))->SetCheck(1);
		((CButton*)GetDlgItem(IDC_TOS_WXP))->EnableWindow(FALSE);
		((CButton*)GetDlgItem(IDC_TOS_WXP))->SetCheck(0);
		((CButton*)GetDlgItem(IDC_TOS_W2K3))->EnableWindow(FALSE);
		((CButton*)GetDlgItem(IDC_TOS_W2K3))->SetCheck(0);
		((CButton*)GetDlgItem(IDC_TOS_W2K8))->EnableWindow(FALSE);
		((CButton*)GetDlgItem(IDC_TOS_W2K8))->SetCheck(0);
		((CButton*)GetDlgItem(IDC_TOS_W7))->EnableWindow(TRUE);
		((CButton*)GetDlgItem(IDC_TOS_W7))->SetCheck(0);
	}
	else if(nOptionID == DDK_WXP)
	{
		((CButton*)GetDlgItem(IDC_TOS_W2K))->EnableWindow(TRUE);
		((CButton*)GetDlgItem(IDC_TOS_W2K))->SetCheck(0);
		((CButton*)GetDlgItem(IDC_TOS_WXP))->EnableWindow(TRUE);
		((CButton*)GetDlgItem(IDC_TOS_WXP))->SetCheck(1);
		((CButton*)GetDlgItem(IDC_TOS_W2K3))->EnableWindow(FALSE);
		((CButton*)GetDlgItem(IDC_TOS_W2K3))->SetCheck(0);
		((CButton*)GetDlgItem(IDC_TOS_W2K8))->EnableWindow(FALSE);
		((CButton*)GetDlgItem(IDC_TOS_W2K8))->SetCheck(0);
		((CButton*)GetDlgItem(IDC_TOS_W7))->EnableWindow(TRUE);
		((CButton*)GetDlgItem(IDC_TOS_W7))->SetCheck(0);
	}
	else if (nOptionID == DDK_W2K3)
	{
		((CButton*)GetDlgItem(IDC_TOS_W2K))->EnableWindow(TRUE);
		((CButton*)GetDlgItem(IDC_TOS_W2K))->SetCheck(0);
		((CButton*)GetDlgItem(IDC_TOS_WXP))->EnableWindow(TRUE);
		((CButton*)GetDlgItem(IDC_TOS_WXP))->SetCheck(1);
		((CButton*)GetDlgItem(IDC_TOS_W2K3))->EnableWindow(TRUE);
		((CButton*)GetDlgItem(IDC_TOS_W2K3))->SetCheck(0);
		((CButton*)GetDlgItem(IDC_TOS_W2K8))->EnableWindow(FALSE);
		((CButton*)GetDlgItem(IDC_TOS_W2K8))->SetCheck(0);
		((CButton*)GetDlgItem(IDC_TOS_W7))->EnableWindow(TRUE);
		((CButton*)GetDlgItem(IDC_TOS_W7))->SetCheck(0);
	}
	else if (nOptionID == DDK_WDK)
	{
		((CButton*)GetDlgItem(IDC_TOS_W2K))->EnableWindow(TRUE);
		((CButton*)GetDlgItem(IDC_TOS_W2K))->SetCheck(0);
		((CButton*)GetDlgItem(IDC_TOS_WXP))->EnableWindow(TRUE);
		((CButton*)GetDlgItem(IDC_TOS_WXP))->SetCheck(0);
		((CButton*)GetDlgItem(IDC_TOS_W2K3))->EnableWindow(TRUE);
		((CButton*)GetDlgItem(IDC_TOS_W2K3))->SetCheck(1);
		((CButton*)GetDlgItem(IDC_TOS_W2K8))->EnableWindow(TRUE);
		((CButton*)GetDlgItem(IDC_TOS_W2K8))->SetCheck(0);
		((CButton*)GetDlgItem(IDC_TOS_W7))->EnableWindow(TRUE);
		((CButton*)GetDlgItem(IDC_TOS_W7))->SetCheck(0);
	}
	else if (nOptionID == DDK_WDK_7)
	{
		((CButton*)GetDlgItem(IDC_TOS_W2K))->EnableWindow(TRUE);
		((CButton*)GetDlgItem(IDC_TOS_W2K))->SetCheck(0);
		((CButton*)GetDlgItem(IDC_TOS_WXP))->EnableWindow(TRUE);
		((CButton*)GetDlgItem(IDC_TOS_WXP))->SetCheck(0);
		((CButton*)GetDlgItem(IDC_TOS_W2K3))->EnableWindow(TRUE);
		((CButton*)GetDlgItem(IDC_TOS_W2K3))->SetCheck(0);
		((CButton*)GetDlgItem(IDC_TOS_W2K8))->EnableWindow(TRUE);
		((CButton*)GetDlgItem(IDC_TOS_W2K8))->SetCheck(0);
		((CButton*)GetDlgItem(IDC_TOS_W7))->EnableWindow(TRUE);
		((CButton*)GetDlgItem(IDC_TOS_W7))->SetCheck(1);
	}
}

void CEasySYSDlg::OnTosW2k() 
{
	if (1 == ((CButton*)GetDlgItem(IDC_TOS_W2K))->GetCheck())
	{
		((CButton*)GetDlgItem(IDC_TOS_WXP))->SetCheck(0);
		((CButton*)GetDlgItem(IDC_TOS_W2K3))->SetCheck(0);
		((CButton*)GetDlgItem(IDC_TOS_W2K8))->SetCheck(0);
	}
}

void CEasySYSDlg::OnTosWXP() 
{
	if (1 == ((CButton*)GetDlgItem(IDC_TOS_WXP))->GetCheck())
	{
		((CButton*)GetDlgItem(IDC_TOS_W2K))->SetCheck(0);
		((CButton*)GetDlgItem(IDC_TOS_W2K3))->SetCheck(0);
		((CButton*)GetDlgItem(IDC_TOS_W2K8))->SetCheck(0);
	}
}

void CEasySYSDlg::OnTosW2K3() 
{
	if (1 == ((CButton*)GetDlgItem(IDC_TOS_W2K3))->GetCheck())
	{
		((CButton*)GetDlgItem(IDC_TOS_W2K))->SetCheck(0);
		((CButton*)GetDlgItem(IDC_TOS_WXP))->SetCheck(0);
		((CButton*)GetDlgItem(IDC_TOS_W2K8))->SetCheck(0);
	}	
}

void CEasySYSDlg::OnTosW2K8() 
{
	if (1 == ((CButton*)GetDlgItem(IDC_TOS_W2K8))->GetCheck())
	{
		((CButton*)GetDlgItem(IDC_TOS_W2K))->SetCheck(0);
		((CButton*)GetDlgItem(IDC_TOS_WXP))->SetCheck(0);
		((CButton*)GetDlgItem(IDC_TOS_W2K3))->SetCheck(0);
	}	
}

void CEasySYSDlg::OnTosW7() 
{
	if (1 == ((CButton*)GetDlgItem(IDC_TOS_W7))->GetCheck())
	{
		((CButton*)GetDlgItem(IDC_TOS_W2K))->SetCheck(0);
		((CButton*)GetDlgItem(IDC_TOS_WXP))->SetCheck(0);
		((CButton*)GetDlgItem(IDC_TOS_W2K3))->SetCheck(0);
		((CButton*)GetDlgItem(IDC_TOS_W2K8))->SetCheck(0);
	}	
}

//set value of g_bufBuildLine (PROJECT_MYBUILD_LINE)
int CEasySYSDlg::SetBuildLineValue()
{
	int nIndex = ((CComboBox *)GetDlgItem(IDC_DDK_VERSION))->GetCurSel();
	int nOptionID = ((CComboBox *)GetDlgItem(IDC_DDK_VERSION))->GetItemData(nIndex);
	
	//according to the (DDK + OS)

	if (nOptionID == DDK_W2K)
	{
		if (1 == ((CButton*)GetDlgItem(IDC_TOS_W2K))->GetCheck())
		{
			g_bufBuildLine = _T("set W2KBASE=C:\\NTDDK\r\nddkbuild.cmd -W2K chk .");
			return 0;
		}
		else
		{
			//MessageBox(_T("Please select more than one target OS."), DIALOG_CAPTION, MB_ICONSTOP);
			return -1;
		}
	}

	if (nOptionID == DDK_WXP)
	{
		if (1 == ((CButton*)GetDlgItem(IDC_TOS_W2K))->GetCheck())
		{
			g_bufBuildLine = _T("set WXPBASE=C:\\WINDDK\\2600\r\nddkbuild.cmd -WXP2K chk .");
			return 0;
		}
		else if (1 == ((CButton*)GetDlgItem(IDC_TOS_WXP))->GetCheck())
		{
			g_bufBuildLine = _T("set WXPBASE=C:\\WINDDK\\2600\r\nddkbuild.cmd -WXP chk .");
			return 0;
		}
		else
		{
			//MessageBox(_T("Please select more than one target OS."), DIALOG_CAPTION, MB_ICONSTOP);
			return -1;
		}		
	}

	if (nOptionID == DDK_W2K3)
	{
		if (1 == ((CButton*)GetDlgItem(IDC_TOS_W2K))->GetCheck())
		{
			g_bufBuildLine = _T("set WNETBASE=C:\\WINDDK\\3790.1830\r\nddkbuild.cmd -WNET2K chk .");
			return 0;
		}
		else if (1 == ((CButton*)GetDlgItem(IDC_TOS_WXP))->GetCheck())
		{
			g_bufBuildLine = _T("set WNETBASE=C:\\WINDDK\\3790.1830\r\nddkbuild.cmd -WNETXP chk .");
			return 0;
		}
		else if(1 == ((CButton*)GetDlgItem(IDC_TOS_W2K3))->GetCheck())
		{
			g_bufBuildLine = _T("set WNETBASE=C:\\WINDDK\\3790.1830\r\nddkbuild.cmd -WNET chk .");
			return 0;
		}
		else
		{
			//MessageBox(_T("Please select more than one target OS."), DIALOG_CAPTION, MB_ICONSTOP);
			return -1;
		}
	}
		
	if (nOptionID == DDK_WDK)
	{
		if (1 == ((CButton*)GetDlgItem(IDC_TOS_W2K))->GetCheck())
		{
			g_bufBuildLine = _T("set WLHBASE=C:\\WINDDK\\6001.18002\r\nset WDF_ROOT=C:\\WINDDK\\6001.18002\r\nddkbuild.cmd -WLH2K chk . -cZ -WDF");
			return 0;
		}
		else if (1 == ((CButton*)GetDlgItem(IDC_TOS_WXP))->GetCheck())
		{
			g_bufBuildLine = _T("set WLHBASE=C:\\WINDDK\\6001.18002\r\nset WDF_ROOT=C:\\WINDDK\\6001.18002\r\nddkbuild.cmd -WLHXP chk . -cZ -WDF");
			return 0;
		}
		else if(1 == ((CButton*)GetDlgItem(IDC_TOS_W2K3))->GetCheck())
		{
			g_bufBuildLine = _T("set WLHBASE=C:\\WINDDK\\6001.18002\r\nset WDF_ROOT=C:\\WINDDK\\6001.18002\r\nddkbuild.cmd -WLHNET chk . -cZ -WDF");
			return 0;
		}
		else if(1 == ((CButton*)GetDlgItem(IDC_TOS_W2K8))->GetCheck()||1 == ((CButton*)GetDlgItem(IDC_TOS_W7))->GetCheck())
		{
			g_bufBuildLine = _T("set WLHBASE=C:\\WINDDK\\6001.18002\r\nset WDF_ROOT=C:\\WINDDK\\6001.18002\r\nddkbuild.cmd -WLH chk . -cZ -WDF");
			return 0;
		}
		else
		{
			//MessageBox(_T("Please select more than one target OS."), DIALOG_CAPTION, MB_ICONSTOP);
			return -1;
		}
	}

	if (nOptionID == DDK_WDK_7)
	{
		if (1 == ((CButton*)GetDlgItem(IDC_TOS_W2K))->GetCheck())
		{
			g_bufBuildLine = _T("set WLHBASE=C:\\WINDDK\\6001.18002\r\nset WDF_ROOT=C:\\WINDDK\\6001.18002\r\nddkbuild.cmd -WLH2K chk . -cZ -WDF");
			return 0;
		}
		else if (1 == ((CButton*)GetDlgItem(IDC_TOS_WXP))->GetCheck())
		{
			g_bufBuildLine = _T("set WLHBASE=C:\\WINDDK\\6001.18002\r\nset WDF_ROOT=C:\\WINDDK\\6001.18002\r\nddkbuild.cmd -WLHXP chk . -cZ -WDF");
			return 0;
		}
		else if(1 == ((CButton*)GetDlgItem(IDC_TOS_W2K3))->GetCheck())
		{
			g_bufBuildLine = _T("set WLHBASE=C:\\WINDDK\\6001.18002\r\nset WDF_ROOT=C:\\WINDDK\\6001.18002\r\nddkbuild.cmd -WLHNET chk . -cZ -WDF");
			return 0;
		}
		else if(1 == ((CButton*)GetDlgItem(IDC_TOS_W2K8))->GetCheck() || 1 == ((CButton*)GetDlgItem(IDC_TOS_W7))->GetCheck())
		{
			g_bufBuildLine = _T("set WLHBASE=C:\\WINDDK\\7600.16385.0\r\nset WDF_ROOT=C:\\WINDDK\\7600.16385.0\r\nddkbuild.cmd -WLH chk . -cZ -WDF");			
			return 0;
		}
		else
		{
			//MessageBox(_T("Please select more than one target OS."), DIALOG_CAPTION, MB_ICONSTOP);
			return -1;
		}
	}
	return 0;
}