// EasySYSDlg.h : header file
//

#if !defined(AFX_EASYSYSDLG_H__17DB3B75_D1A3_4712_A7DE_3AAB2B1E0C41__INCLUDED_)
#define AFX_EASYSYSDLG_H__17DB3B75_D1A3_4712_A7DE_3AAB2B1E0C41__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000


#include "resource.h"
#include "trayicon.h"

/////////////////////////////////////////////////////////////////////////////
// CEasySYSDlg dialog

class CEasySYSDlg : public CDialog
{
// Construction
public:
	BOOL ReadPathFromReg();
	BOOL SavePathToReg();
	CEasySYSDlg(CWnd* pParent = NULL);	// standard constructor

	int type;

// Dialog Data
	//{{AFX_DATA(CEasySYSDlg)
	enum { IDD = IDD_EASYSYS_DIALOG };
	CString	m_strPrjName;
	CString	m_strPrjPath;
	CComboBox	m_IDEType;
	CString	m_strPrjAuthor;
	CString	m_strPrjComment;
	BOOL	m_bOpenFolder;
	BOOL	m_bOpenProject;
	BOOL	m_bAutoQuit;
	BOOL	m_bCreateTestApp;
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CEasySYSDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	HICON m_hIcon;
	CTrayIcon m_trayIcon;	

	// Generated message map functions
	//{{AFX_MSG(CEasySYSDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	afx_msg void OnBrowseFolder();
	afx_msg void OnCreate();
	afx_msg void OnSelchangeDdkVersion();
	afx_msg void OnSelectIdeType();
	afx_msg void OnCreateName();
	afx_msg LRESULT OnTrayNotification(WPARAM wp, LPARAM lp);
	afx_msg void OnAppOpen();
	afx_msg void OnAppSuspend();
	afx_msg void OnChangeAuthor();
	virtual void OnCancel();
	afx_msg void OnTosW2k();
	afx_msg void OnTosWXP();
	afx_msg void OnTosW2K3();
	afx_msg void OnTosW2K8();
	afx_msg void OnTosW7();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
private:
	int GetDDKLocation(CString &);
	int CreateSysProject();
	int CreateSysProject_vc6();
	int CreateConsoleProject();
	int CreateConsoleProject_vc6();
	
	BOOL CheckDDKEnvironment();
	BOOL SetDDKEnvironment(CString &);
	BOOL CheckDDK();
	BOOL CheckTargetOS();
	void GetDDKPath();

	int SetBuildLineValue();

	//
	CString m_strDDKVer;
	int m_nTosNum;
	//
	CButton m_btnBrowser;
	CButton m_btnName;
	CButton	m_btnCreate;
    CButton	m_btnClose;

	CString m_strDate;

};
CString LoadText(LPCTSTR lpName);
CString LoadTextById(int);


//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_EASYSYSDLG_H__17DB3B75_D1A3_4712_A7DE_3AAB2B1E0C41__INCLUDED_)
